(function() {

    // Crashes:
    //  https://github.com/floatinghotpot/cordova-plugin-admob

    // TODO: Testing new AdMob Plugin:
    //  https://github.com/aliokan/cordova-plugin-admob/

    // TODO: Activate COPPA stuff
    //  https://developers.google.com/mobile-ads-sdk/docs/admob/additional-controls

    //if (!window.plugins || !window.plugins.AdMob) {
    if (!window.admob) {
        return;
    }

    var Ad = function() {

        var self = this;
        var clbk = null;

        self.visible = false;

        var _publisherId = null;
        var _testing = false;

        function callback(evt) {
            if (!evt || !evt.type) return;

            if (evt.type == 'onReceiveAd') {
                self.visible = true;
                if (clbk) {
                    clbk(Game.Ad.MESSAGE_AD_RECEIVED);
                }
            } else if (evt.type == 'onDismissAd') {
                self.visible = false;
            } else if (evt.type == 'onFailedToReceiveAd') {
                self.hideAd();
            }
        }

        function admobError(error, info) {
            console.log("AdMob Error: " + JSON.stringify(error) + (info) ? info : "");
        }

        self.loadAd = function(publisherId, onCallback, testing) {
            if (self.visible) {
                if (onCallback) { onCallback(Game.Ad.MESSAGE_AD_RECEIVED) };
                return;
            }
            self.visible = true;
            testing = (testing == undefined) ? false : testing;
            _publisherId = publisherId;
            _testing = testing;
            clbk = onCallback;

            var successCreateBannerView = function() { admob.requestAd({'isTesting': testing},success,error); };
            var success = function() { };
            var error = function(message) { console.log("Error: " + message); };

            var options = {
                'publisherId': publisherId,
                'adSize': admob.AD_SIZE.SMART_BANNER,
                'extras': {
                    'color_bg': '000000',
                    'color_bg_top': '000000',
                    'color_border': '000000'
                }
            }
            admob.createBannerView(options, successCreateBannerView, error);
        };

        self.hideAd = function(callback) {
            if (!self.visible) {
                if (callback) { callback(); }
                return;
            }

            admob.killAd(function() {
                var evt = document.createEvent("Events");
                evt.initEvent("onDismissAd", true, true);
                document.dispatchEvent(evt);
                if (callback) {
                    callback();
                }
            }, function() {
                console.log('error');
            });
        };

        self.reloadAd = function(onComplete) {
            self.loadAd(_publisherId, onComplete, _testing);
        };

        document.addEventListener('onReceiveAd', callback, false);
        document.addEventListener('onFailedToReceiveAd', callback, false);
        document.addEventListener('onPresentAd', callback, false);
        document.addEventListener('onDismissAd', callback, false);
        document.addEventListener('onLeaveToAd', callback, false);

    };


    Game.Ad = new Ad();

    Game.Ad.MESSAGE_AD_RECEIVED = "onReceiveAd";


})();