(function() {

    var ImageLoader = function() {

        var self = this;
        var sources = [];

        self.addSource = function(src) {
            sources.push(src);
            return self;
        };

        self.addSources = function(srcs) {
            srcs.forEach(function(src) {
                self.addSource(src);
            });
            return self;
        }

        self.load = function(callback) {
            var images = {};
            var toLoad = sources.length;
            var loaded = 0;

            if (toLoad == 0) { callback(images); return; }

            sources.forEach(function(source) {
                var img = new Image();
                img.onload = function() {
                    images[(source.name || source.src || source)] = img;
                    loaded++;
                    if (loaded == toLoad) {
                        callback(images);
                    }
                };
                img.src = (source.src || source);
            });
        };

    };

    window.Game.ImageLoader = ImageLoader;

})();