(function() {
    var PuzzleChooserController = function() {

        var self = this;

        function allButtonsLoaded(node, buttonElements) {
            for (var i = 0; i < buttonElements.length; i++) {
                node.appendChild(buttonElements[i]);
            }
            buttonElements.length = 0;
        }

        self.createButtons = function(puzzles) {
            var numGenerated = 0;
            var buttonElements = [];
            var rootNode = document.querySelector("#puzzlechooser ul");
            rootNode.innerHTML = "";
            puzzles.forEach(function(puzzle, index) {
                var li = document.createElement("li");

                var span = document.createElement("span");
                span.innerHTML = puzzle.title;
                li.appendChild(span);

                if (Game.Support.Touch) {
                    var touchWasMoved = false;

                    li.addEventListener("touchstart", function(evt) {
                        touchWasMoved = false;
                        li.className = "active";
                        Game.Utils.ForceDOMRedraw(li);
                    }, false);

                    li.addEventListener("touchmove", function(evt) {
                        if (!touchWasMoved) {
                            li.className = "";
                            Game.Utils.ForceDOMRedraw(li);
                        }
                        touchWasMoved = true;
                    }, false);

                    li.addEventListener("touchend", function(evt) {
                        li.className = "";
                        Game.Utils.ForceDOMRedraw(li);

                        if (!touchWasMoved) {
                            setTimeout(function() {
                                Game.Start(index);
                            }, 150);
                        }

                        touchWasMoved = false;
                    }, false);

                    li.addEventListener("touchcancel", function(evt) {
                        li.className = "";
                        Game.Utils.ForceDOMRedraw(li);

                        if (!touchWasMoved) {
                            setTimeout(function() {
                                Game.Start(index);
                            }, 150);
                        }

                        touchWasMoved = false;
                    }, false);
                } else {
                    li.addEventListener("click", function(evt) {
                        Game.Start(index);
                    }, false);
                }

                var img = new Image();
                img.onload = function() {
                    img.setAttribute("width", "75%");
                    li.appendChild(img);
                    buttonElements[index] = li;
                    numGenerated++;
                    if (numGenerated == puzzles.length) {
                        allButtonsLoaded(rootNode, buttonElements);
                    }
                };
                img.src = "puzzles/"+puzzle.file;

            });
        };

    };


    var _oldSize = null;

    function updateSize() {
        /*var rootNode = document.querySelector("#puzzlechooser");
        if (_oldSize == null) { _oldSize = rootNode.clientHeight; }
        _oldSize = Math.max(Math.round(rootNode.clientWidth * 0.30), _oldSize);
        rootNode.style.height = _oldSize + "px";*/
    }

    updateSize();


    Game.PuzzleChooserController = new PuzzleChooserController();

    window.addEventListener("orientationchange", function() {
        setTimeout(updateSize, 1000);
    }, false);

})();