(function() {

    var settingsNode = document.getElementById("settings");

    var musicVolumeSlide = settingsNode.querySelector("input[name='MusicVolume']");

    var sfxVolumeSlide = settingsNode.querySelector("input[name='SFXVolume']");

    var difficultySlide = settingsNode.querySelector("input[name='Difficulty']");
    var difficultyLabel = settingsNode.querySelector("label.Difficulty");
    var difficultyNames = ["2x2 Grid", "3x3 Grid"];

    var rotatableSlide = settingsNode.querySelector("input[name='Rotatable']");
    //var rotatableLabel = settingsNode.querySelector("label.Rotatable");
    var rotatableNames = ["Off", "On"];


    // "mouseup" doesn't work reliable here, so we have to use "touchend"

    musicVolumeSlide.addEventListener("change", function() {
        Game.Audio.setVolumeMusic(musicVolumeSlide.value / 100.0);
    }, false);
    musicVolumeSlide.addEventListener("touchend", function() {
        Game.Cache.set("volumeMusic", musicVolumeSlide.value / 100.0);
        Game.Cache.set("enabledMusic", "" + (musicVolumeSlide.value > 0));
        if (musicVolumeSlide.value > 0) {
            Game.Audio.MusicBackground.loop();
        } else {
            Game.Audio.MusicBackground.stop();
        }
        Game.Audio.setVolumeMusic(musicVolumeSlide.value / 100.0);
        Game.Audio.SFXTap.play();
    }, false);


    sfxVolumeSlide.addEventListener("change", function() {
        Game.Audio.setVolumeSFX(sfxVolumeSlide.value / 100.0);
    }, false);
    sfxVolumeSlide.addEventListener("touchend", function() {
        Game.Cache.set("volumeSFX", sfxVolumeSlide.value / 100.0);
        Game.Cache.set("enabledSFX", "" + (sfxVolumeSlide.value > 0));
        Game.Audio.SFXTap.play();
    }, false);


    difficultySlide.addEventListener("change", function() {
        difficultyLabel.innerText = Localization.get("settings_"+difficultyNames[difficultySlide.value]);
        Game.Cache.set("difficulty", difficultySlide.value);
        Game.Audio.SFXTap.play();
    }, false);


    rotatableSlide.addEventListener("change", function() {
        //rotatableLabel.innerText = Localization.get("settings_"+rotatableNames[rotatableSlide.value]);
        Game.Cache.set("rotatable", rotatableSlide.value);
        Game.Audio.SFXTap.play();
    }, false);


    // Translate titles

    function translateTitle(selector, key) {
        document.querySelector(selector).innerText = Localization.get(key);
    }

    setTimeout(function() {
        musicVolumeSlide.value = parseFloat(Game.Cache.getDef("volumeMusic", 0.5)) * 100;
        sfxVolumeSlide.value = parseFloat(Game.Cache.getDef("volumeSFX", 1.0)) * 100;
        difficultySlide.value = parseInt(Game.Cache.getDef("difficulty", 1));
        rotatableSlide.value = parseInt(Game.Cache.getDef("rotatable", 0));

        //rotatableLabel.innerText = Localization.get("settings_"+rotatableNames[parseInt(Game.Cache.getDef("rotatable", 0))]);
        difficultyLabel.innerText = Localization.get("settings_"+difficultyNames[parseInt(Game.Cache.getDef("difficulty", 1))]);

        /*translateTitle("#settings th.music",    "settings_Music");
        translateTitle("#settings th.sound",    "settings_Sound");
        translateTitle("#settings th.level",    "settings_Level");
        translateTitle("#settings th.rotation", "settings_Rotation");*/
    }, 2000);

})();