(function() {

    // States
    var States = {
        Info: "info",
        Home: "home",
        Settings: "settings",
        Game: "game"
    };

    var currentState = States.Home;


    // Actions
    function ActionInfo() {
        changeState(States.Info);
    }

    function ActionHome() {
        changeState(States.Home);
    }

    function ActionSettings() {
        changeState(States.Settings);
    }

    function ActionGame() {
        changeState(States.Game);
    }

    function ActionNextPuzzle() {
        Game.Next();
    }

    function ActionPreviousPuzzle() {
        Game.Previous();
    }

    function ActionResetPuzzle() {
        //changeState(States.Game);
        Game.Reset(true);
    }

    // Change State
    function changeState(newState) {
        Game.Audio.SFXTap.play();

        if (newState == currentState) return;

        if (currentState == States.Game) {
            Game.OnExit();
        }

        document.getElementById(currentState).style.display = "none";
        document.getElementById(newState).style.display = "block";

        currentState = newState;
    }


    // Register Button handlers
    var nodes = null;

    // Hook up all buttons: Info
    nodes = document.querySelectorAll(".topbar .button.info");
    for (var i = 0; i < nodes.length; i++) {
        nodes[i].addEventListener(Game.Support.ButtonActionEventName(), function() {
            ActionInfo();
        }, false);
    }

    // Hook up all buttons: Home
    nodes = document.querySelectorAll(".topbar .button.home");
    for (var i = 0; i < nodes.length; i++) {
        nodes[i].addEventListener(Game.Support.ButtonActionEventName(), function() {
            ActionHome();
        }, false);
    }

    // Hook up all buttons: Settings
    nodes = document.querySelectorAll(".topbar .button.settings");
    for (var i = 0; i < nodes.length; i++) {
        nodes[i].addEventListener(Game.Support.ButtonActionEventName(), function() {
            ActionSettings();
        }, false);
    }

    // Hook up all buttons: Next
    nodes = document.querySelectorAll(".topbar .button.next");
    for (var i = 0; i < nodes.length; i++) {
        nodes[i].addEventListener(Game.Support.ButtonActionEventName(), function() {
            ActionNextPuzzle();
        }, false);
    }

    // Hook up all buttons: Previous
    nodes = document.querySelectorAll(".topbar .button.previous");
    for (var i = 0; i < nodes.length; i++) {
        nodes[i].addEventListener(Game.Support.ButtonActionEventName(), function() {
            ActionPreviousPuzzle();
        }, false);
    }

    // Hook up all buttons: Reset
    nodes = document.querySelectorAll(".topbar .button.reset");
    for (var i = 0; i < nodes.length; i++) {
        nodes[i].addEventListener(Game.Support.ButtonActionEventName(), function() {
            ActionResetPuzzle();
        }, false);
    }

    window.Game.TopbarController = {
        GameStarted: function() {
            ActionGame();
        }
    };

})();